/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/
import java.awt.*;

import javax.swing.*;

import li.netcat.chart.*;
import li.netcat.chart.util.*;

public class LayoutExample {
  
  public static void main(String[] args)	{
    FrameHelper.open(createChart());
  }
  
  public static Chart createChart() {
    PanelPart panel = new PanelPart();
    PanelPartConstraints c = PanelPartConstraints.DEFAULT;
    Part partA = createPart("A", 35);
    Part partB = createPart("B", 10);
    Part partC = createPart("C", 15);
    Part partD = createPart("D", 20);
    Part partE = createPart("E", 30);
    Part partF = createPart("F", 5);
    panel.addPart(partA);
    panel.addPart(partB, c.anchorSouthEast().targetWest());
    panel.addPart(partC, c.anchorEast().targetWest().shiftX(2));
    panel.addPart(partD, c.anchorSouth().targetNorth().referenceX(partA));
    panel.addPart(partE, c.anchorCenter().targetCenter().referenceX(partB).referenceY(partD));
    panel.addPart(partF, c.anchor(1.0f/3.0f, 0.0f).targetNorth().reference(partA));
    return new Chart(panel);
  }
  
  public static Part createPart(String text, int inset) {
    BorderPart borderPart = new BorderPart(new LabelPart(text));
    borderPart.setInsets(inset, inset, inset, inset);
    return borderPart;
  }
  
}
