/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license 
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import li.netcat.chart.*;

import java.util.*;

public class SimpleChartModel extends AbstractChartModel {
  private Map _texts = new HashMap();
  private int _rowCount;
  private int _columnCount;

  //// constructors
  
  public SimpleChartModel(int rowCount, int columnCount, String title, String x, String y) {
    this(rowCount, columnCount);
    setText("title", title);
    setText("x", x);
    setText("y", y);
  }

  public SimpleChartModel(int rowCount, int columnCount) {
    _rowCount = rowCount;
    _columnCount = columnCount;
  }
  
  //// interface ChartModel
  
  public int getRowCount() {
    return _rowCount;
  }
  
  public int getColumnCount() {
    return _columnCount;
  }
  
  public Object getValueAt(int rowIndex, int columnIndex) {
    return new Integer((1+rowIndex) * (1+columnIndex)); 
  }
  
  public String getTextForKey(String key) {
    return (String)_texts.get(key);
  }
  
  //// private methods
  
  private void setText(String key, String text) {
    _texts.put(key, text);
  }
  
}
