/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license 
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import li.netcat.chart.*;

import java.util.*;


public class SumRowsChartModel extends AbstractChartModel implements ChartModelListener {
  private Object[]   _values;
  private ChartModel _chartModel;

  //// constructors
  
  public SumRowsChartModel(ChartModel chartModel) {
    _chartModel = chartModel;
    _chartModel.addChartModelListener(this);
  }

  //// interface ChartModel

  public int getRowCount() {
    return 1;
  }
  
  public int getColumnCount() {
    return _chartModel.getColumnCount();
  }
  
  public Object getValueAt(int rowIndex, int columnIndex) {
    return getValues()[columnIndex];
  }
  
  public String getTextAt(int rowIndex, int columnIndex) {
    return getTextForColumn(columnIndex);
  }
  
  public String getTextForRow(int rowIndex) {
    return null;
  }

  public String getTextForColumn(int columnIndex) {
    return _chartModel.getTextForColumn(columnIndex);
  }
  
  public String getTextForKey(String key) {
    return _chartModel.getTextForKey(key);
  }
  
  //// interface ChartModelListener
  
  public void onChartModelChange(ChartModelEvent event) {
    _values = null;
    fireChartModelEvent(this);
  }
  
  //// private helpers
  
  private Object[] getValues() {
    if (_values == null) {
      _values = new Object[_chartModel.getColumnCount()];
      int rows = _chartModel.getRowCount();
      for (int col=0; col<_values.length; col++) {
        double sum = 0.0;
        for (int row=0; row<rows; row++) {
          Object value = _chartModel.getValueAt(row, col);
          if (value instanceof Number) {
            sum += ((Number)value).doubleValue();
          }
        }
        _values[col] = new Double(sum);
      }
    }
    return _values;
  }
  
}
