/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/
import java.text.*;

import li.netcat.chart.*;
import li.netcat.chart.util.*;
import li.netcat.chart.util.tag.*;

public class TagExample {
  
  public static void main(String[] args)	{
    ChartModel model = new SalesModel();
    FrameHelper.open(new Chart[]{new BarChart(model), new BarChart2(model), new PieChart(new KidsModel())}, 1, -1);
  }

  public static class BarChart extends Chart {
            
    public BarChart(ChartModel chartModel) {
      BarPart barPart = new BarPart(chartModel);
      barPart.setSize(100, 75);
      CartesianInscribePart inscribePart = new CartesianInscribePart(barPart);
      DefaultTagManager tagManager = new DefaultTagManager(DefaultTagManager.STYLE_TURN, DefaultTagManager.METHOD_MOVE);
      tagManager.setTurnTextLineGap(0);
      inscribePart.setTagManager(tagManager);
      inscribePart.setPosition(ChartConstants.TOP);
      inscribePart.setTargetPosition(1, -3, 0, 0);
      CartesianScalePart scaleX = new CartesianScalePart(barPart, ChartConstants.BOTTOM);
      scaleX.setTagManager(new DefaultTagManager(DefaultTagManager.STYLE_UNDERLINE, DefaultTagManager.METHOD_MOVE));
      CartesianScalePart scaleY = new CartesianScalePart(barPart, ChartConstants.LEFT);
      scaleY.setTagManager(new DefaultTagManager(DefaultTagManager.STYLE_DASH, DefaultTagManager.METHOD_MOVE));
      CartesianGridPart grid = new CartesianGridPart(barPart);
      grid.setPaintBorderFlags(false, false, false, false);
      grid.setPaintMarksFlags(false, false, false, false);
      grid.setBackgroundPaint(null);
      PanelPart panel = new PanelPart();
      panel.addPart(grid);
      panel.addPart(barPart);
      panel.addPart(inscribePart);
      panel.addPart(scaleX);
      panel.addPart(scaleY);
      setContent(panel);
    }
  }
          
  public static class BarChart2 extends Chart {
            
    public BarChart2(ChartModel chartModel) {
      BarPart barPart = new BarPart(chartModel);
      barPart.setSize(110, 75);
      DirectInscribePart inscribePart = new DirectInscribePart(barPart);
      BasicTagManager tagManager = new BasicTagManager(ChartConstants.LEFT, ChartConstants.CENTER, 90);
      inscribePart.setTagManager(tagManager);
      inscribePart.setTextLook(TextLook.getDefaultNormal());
      inscribePart.setTargetPosition(0, 5, 0, 0);
      CartesianScalePart scaleX = new CartesianScalePart(barPart, ChartConstants.BOTTOM);
      scaleX.setTagManager(new DefaultTagManager(DefaultTagManager.STYLE_TURN, DefaultTagManager.METHOD_MOVE));
      CartesianScalePart scaleY = new CartesianScalePart(barPart, ChartConstants.LEFT);
      scaleY.setTagManager(new DefaultTagManager(DefaultTagManager.STYLE_UNDERLINE, DefaultTagManager.METHOD_REMOVE));
      CartesianGridPart grid = new CartesianGridPart(barPart);
      grid.setPaintBorderFlags(false, false, false, false);
      grid.setPaintMarksFlags(false, false, false, false);
      grid.setBackgroundPaint(null);
      PanelPart panel = new PanelPart();
      panel.addPart(grid);
      panel.addPart(barPart);
      panel.addPart(inscribePart);
      panel.addPart(scaleX);
      panel.addPart(scaleY);
      setContent(panel);
    }
  }
  
  public static class PieChart extends Chart {
    
    public PieChart(ChartModel chartModel) {
      RingPart ringPart = new RingPart(chartModel);
      ringPart.setSize(50, 0);
      PanelPart panel = new PanelPart();
      panel.addPart(ringPart);
      panel.addPart(new PolarInscribePart(ringPart));
      setContent(panel);
    }
  }
  
  
  public static class KidsModel extends ExampleChartModel {
    
    public KidsModel() {
      super(
          new String[] {"Kids"},
          new String[] {
            "Ehrfried",
            "Gumbold",
            "Helmke",
            "Bonifatius",
            "Ebergard",
            "Douglas",
            "Ettina",
            "Branka",
            "Hannerose",
            "Guntfried",
            "Emmeline",
            "Enkeawos",
            "Burchard",
            "Corrado",
            "Friedger",
            "Lanzelot",
            "Riccarda",
            "Talida",
            "Gombert",
            "Gilbert",
            "Ameline",
            "Jerry",
          }, 
          //new int[] {1, 2, 5, 3, 5, 2, 6, 3, 1, 5, 4, 2, 2, 2, 3, 1, 3, 3});
          new int[] {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1});
         // new int[] {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22});
    }
    
    public String getTextAt(int rowIndex, int columnIndex) {
      return getTextForColumn(columnIndex);
    }
  }
  
  
  public static class SalesModel extends ExampleChartModel {
    private static NumberFormat _format = new DecimalFormat("#,###,###,##0");
    
    public SalesModel() {
      super(
          new String[] {"Januar", "Februar", "Mrz", "April"}, 
          new String[] {"Umsatz"},
          new int[] {154000, 162000, 141000, 175000});
    }
    
    public String getTextAt(int rowIndex, int columnIndex) {
      Object value = getValueAt(rowIndex, columnIndex);
      return value == null ? null : _format.format(value);
    }
  }

}
