/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat Inc.  You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat Inc.

   Copyright (c) 2003 - 2004 by NetCat Inc., www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/
import java.text.*;

import java.awt.*;
import java.awt.image.*;

import li.netcat.chart.*;
import li.netcat.chart.util.*;
import li.netcat.chart.util.tag.*;

public class TextureExample {
  
  public static void main(String[] args)	{
    ChartModel model = new SalesModel();
    FrameHelper.open(new AreaChart(model));
  }

  public static class AreaChart extends Chart {
      
    public AreaChart(ChartModel chartModel) {
      // prepare the area part
      AreaPart areaPart = new AreaPart(chartModel, ChartConstants.STACK_TYPE_STACKED, ChartConstants.HORIZONTAL);
      // create own graph look
      GraphLook graphLook = new GraphLook();
      graphLook.setAreaChartPens(createAreaChartPens());
      // set new graph look to chart.
      areaPart.setGraphLook(graphLook);
      // prepare the grid
      CartesianGridPart grid = new CartesianGridPart(areaPart);
      grid.setBackgroundPaint(null);
      // prepare the scales and legend
      CartesianScalePart scaleX = new CartesianScalePart(areaPart, ChartConstants.BOTTOM);
      CartesianScalePart scaleY = new CartesianScalePart(areaPart, ChartConstants.LEFT);
      AreaLegendPart legend = new AreaLegendPart(areaPart);
      legend.setSquareSize(14);
      // add everythig to a panel
      PanelPart panel = new PanelPart();
      PanelPartConstraints c = PanelPartConstraints.DEFAULT;
      panel.addPart(grid);
      panel.addPart(areaPart);
      panel.addPart(scaleX);
      panel.addPart(scaleY);
      BorderPart borderPart = new BorderPart(legend);
      panel.addPart(borderPart, c.reference(grid).anchorEast().targetWest().shiftX(10));
      setContent(panel);
    }
  }
    
  public static Pen[] createAreaChartPens() {
    return new Pen[]{createAreaPen1(),createAreaPen2(),createAreaPen3()};
  }
  
  private static Pen createAreaPen1() {
    BufferedImage image = new BufferedImage(5, 5, BufferedImage.TYPE_INT_RGB); 
    Graphics2D g = image.createGraphics(); 
    g.setColor(Color.white); 
    g.fillRect(0,0,5,5);
    g.setColor(Color.black);
    g.fillRect(2, 0, 1, 5);
    g.dispose();
    Rectangle r = new Rectangle(0,0,5,5); 
    return Pen.getDefaultCapButt().fillPaint(new TexturePaint(image, r));
  }
  
  private static Pen createAreaPen2() {
    BufferedImage image = new BufferedImage(5, 5, BufferedImage.TYPE_INT_RGB); 
    Graphics2D g = image.createGraphics(); 
    g.setColor(Color.white); 
    g.fillRect(0,0,5,5);
    g.setColor(Color.black);
    g.fillRect(0, 2, 5, 1);
    g.dispose();
    Rectangle r = new Rectangle(0,0,5,5); 
    return Pen.getDefaultCapButt().fillPaint(new TexturePaint(image, r));
  }

  private static Pen createAreaPen3() {
    BufferedImage image = new BufferedImage(9, 9, BufferedImage.TYPE_INT_RGB); 
    Graphics2D g = image.createGraphics(); 
    g.setColor(Color.white); 
    g.fillRect(0,0,9,9);
    g.setColor(Color.black);
    g.drawLine(0, 0, 9, 9);
    g.drawLine(0, 9, 9, 0);
    g.dispose();
    Rectangle r = new Rectangle(0,0,9,9); 
    return Pen.getDefaultCapButt().fillPaint(new TexturePaint(image, r));
  }
  
  public static class SalesModel extends ExampleChartModel {
    
    public SalesModel() {
      super(
          new String[] {"Januar", "Februar", "Mrz", "April", "Mai", "Juni"}, 
          new String[] {"Nebel", "Schnee", "Regen"},
          new int[] {
            4, 5, 8, 3, 4, 6,
            40, 45, 17, 7, 0, 0,
            0, 5, 20, 35, 60, 40,
      });
    }
  }
}
